using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace FaceRecognitionDemo
{
    public partial class Form1 : Form
    {
        private int mExpectedID;
        private int mResultCategory;
        private double mDistance;
        private int mErrorCount;
        private int mTotalCount;

        public Form1()
        {
            InitializeComponent();
        }

        private void trainButton_Click(object sender, EventArgs e)
        {
            progressBar1.Maximum = 40;
            byte[] grayValues = new byte[32 * 32];
            Mitov.SignalLab.RealBuffer AFeaturesBuffer = new Mitov.SignalLab.RealBuffer(32 * 32);
            listView1.BeginUpdate();
            for( int i = 1; i <= 40; i ++ )
                for (int j = 1; j <= 9; j++)
                {
                    System.Drawing.Bitmap ABitmep = new System.Drawing.Bitmap(@"C:\Conferences\CodeRage XI\AI\Sources\Data\Faces\Train_" + i.ToString() + "_" + j.ToString() + ".bmp");
                    imageList1.Images.Add(ABitmep);
                    ListViewItem AItem = listView1.Items.Add( i.ToString() );
                    AItem.ImageIndex = imageList1.Images.Count - 1;
                    Rectangle rect = new Rectangle(0, 0, ABitmep.Width, ABitmep.Height);
                    System.Drawing.Imaging.BitmapData bmpData = ABitmep.LockBits(rect, System.Drawing.Imaging.ImageLockMode.ReadOnly, ABitmep.PixelFormat);
                    IntPtr ptr = bmpData.Scan0;
                    System.Runtime.InteropServices.Marshal.Copy(ptr, grayValues, 0, ABitmep.Width * ABitmep.Height);

                    for (uint k = 0; k < AFeaturesBuffer.GetSize(); k++)
                        AFeaturesBuffer[k] = (double)grayValues[k] / 256;

                    ABitmep.UnlockBits(bmpData);

                    radialBasisFunctionNetwork1.Train(AFeaturesBuffer, i);

                    progressBar1.Value = i;
                }

            listView1.EndUpdate();
            recognizeButton.Enabled = true;
            trainButton.Enabled = false;
            trainLabel.Text = radialBasisFunctionNetwork1.Neurons.Count.ToString() + " Neurons used.";
        }

        private void recognizeButton_Click(object sender, EventArgs e)
        {
            mTotalCount = 0;
            mErrorCount = 0;

            progressBar1.Maximum = 40;
            byte[] grayValues = new byte[32 * 32];
            Mitov.SignalLab.RealBuffer AFeaturesBuffer = new Mitov.SignalLab.RealBuffer(32 * 32);

            listView2.BeginUpdate();
            for (int i = 1; i <= 40; i++)
            {
                mExpectedID = i;
                System.Drawing.Bitmap ABitmep = new System.Drawing.Bitmap(@"C:\Conferences\CodeRage XI\AI\Sources\Data\Faces\Reco_" + i.ToString() + ".bmp");
                imageList1.Images.Add(ABitmep);
                ListViewItem AItem = listView2.Items.Add(i.ToString());
                AItem.ImageIndex = imageList1.Images.Count - 1;
                Rectangle rect = new Rectangle(0, 0, ABitmep.Width, ABitmep.Height);
                System.Drawing.Imaging.BitmapData bmpData = ABitmep.LockBits(rect, System.Drawing.Imaging.ImageLockMode.ReadOnly, ABitmep.PixelFormat);
                IntPtr ptr = bmpData.Scan0;
                System.Runtime.InteropServices.Marshal.Copy(ptr, grayValues, 0, ABitmep.Width * ABitmep.Height);

                for (uint k = 0; k < AFeaturesBuffer.GetSize(); k++)
                    AFeaturesBuffer[k] = (double)grayValues[k] / 256;

                ABitmep.UnlockBits(bmpData);
                
                radialBasisFunctionNetwork1.Predict(AFeaturesBuffer);

                if (mResultCategory != i)
                {
                    if (mResultCategory == 0)
                        AItem.Text = "Error - Can't recognize";

                    else
                        AItem.Text = "Error - Expected:" + i.ToString() + " recognized as: " + mResultCategory + " Distance: " + mDistance;

                }

                else
                    AItem.Text = "Correct: " + i.ToString() + " Distance: " + mDistance;


                progressBar1.Value = i;
            }

            listView2.EndUpdate();

            recognizeLabel.Text = mErrorCount.ToString() + " errors of " + mTotalCount.ToString() + " faces - " + ((float)(mTotalCount - mErrorCount) * 100 / mTotalCount).ToString() + "% correct";
            recognizeButton.Enabled = false;
        }

        private void radialBasisFunctionNetwork1_Result(object Sender, Mitov.IntelligenceLab.RadialBasisFunctionResultEventArgs Args)
        {
            ++mTotalCount;
            if (Args.Result.Count == 0)
            {
                ++mErrorCount;
                mResultCategory = 0;
                mDistance = 0;
            }

            else
            {
                mResultCategory = (int)( Args.Result.get_Items(0).Neuron.Category + 0.5 );
                mDistance = Args.Result.get_Items(0).Distance;
                if (mExpectedID != mResultCategory)
                    ++mErrorCount;

            }
        }
    }
}