﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace FindFacesRotatedTraining
{
    public partial class Form1 : Form
    {
        public class Detection
        {
            public int Index;
            public Point Position;
            public double Distance;

            public Detection(int AIndex, Point APosition, double ADistance)
            {
                Index = AIndex;
                Position = APosition;
                Distance = ADistance;
            }
        }

        private System.Collections.Generic.List<Detection> FDetections = new System.Collections.Generic.List<Detection>();
        private bool FRunning = true;

        public Form1()
        {
            InitializeComponent();
            radialBasisFunctionNetwork1.LoadFromFile("C:\\Conferences\\CodeRage XI\\AI\\Sources\\Files\\MaskedRotatedFaceTraining14x14_BKG.ctd");
        }

        private void genericFilter1_ProcessData(object Sender, Mitov.VideoLab.ProcessVideoNotifyArgs Args)
        {
            if (!FRunning)
            {
                Args.SendOutputData = false;
                return;
            }

            FRunning = false;

            Args.InBuffer.SetFormat(Mitov.VideoLab.VideoFormat.GrayScale);
            genericFilter2.SendStartCommand((uint)Args.InBuffer.GetWidth(), (uint)Args.InBuffer.GetHeight(), 1000);
            genericFilter2.SendData(Args.InBuffer);
            genericFilter2.SendStopCommand();

            System.Drawing.Font AFont = new System.Drawing.Font("Arial", 10);

            System.Drawing.Bitmap aBitmap = Args.InBuffer.ToBitmap();
            System.Drawing.Graphics AGraphics = System.Drawing.Graphics.FromImage(aBitmap);

            FDetections.ForEach(
                    delegate(Detection ADetection)
                    {
                        AGraphics.DrawRectangle(System.Drawing.Pens.Red, ADetection.Position.X - 16, ADetection.Position.Y - 16, 46, 46);
                        AGraphics.DrawString(ADetection.Index.ToString(), AFont, System.Drawing.Brushes.Red, ADetection.Position);
                    }
                );

            imageDisplay1.DisplayBitmap(aBitmap);
        }

        private void genericFilter3_ProcessData(object Sender, Mitov.VideoLab.ProcessVideoNotifyArgs Args)
        {
            Mitov.SignalLab.BlockBuffer AFeaturesBuffer = new Mitov.SignalLab.BlockBuffer(14 * 14);
            Args.InBuffer.SetFormat(Mitov.VideoLab.VideoFormat.GrayScale);
            for (int i = 0; i < 14 * 14; ++i)
                AFeaturesBuffer[i] = (byte)Args.InBuffer.GetGrayScale(i % 14, i / 14);

            radialBasisFunctionNetwork1.Predict(AFeaturesBuffer);
        }

        private void radialBasisFunctionNetwork1_Result(object Sender, Mitov.IntelligenceLab.RadialBasisFunctionResultEventArgs Args)
        {
            if (Args.Result.Count == 0)
                return;

            int ACategory = (int)System.Math.Round(Args.Result.get_Items(0).Neuron.Category);

            if( ACategory == -1 )
                return;

            Point ADetectedPosition = sampler1.CurrectPosition;
            double ADistance = Args.Result.get_Items(0).Distance;

            FDetections.Add(new Detection(ACategory, ADetectedPosition, ADistance));
        }
    }
}
