﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace NeuralNetworkFunctionApproximation
{
    public partial class Form1 : Form
    {
        protected const int SAMPLES = 26;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Mitov.SignalLab.RealMatrixBuffer ATrainingData = new Mitov.SignalLab.RealMatrixBuffer(SAMPLES, 1);
            Mitov.SignalLab.RealMatrixBuffer AResponses = new Mitov.SignalLab.RealMatrixBuffer(SAMPLES, 1);

            scope1.Channels[0].Data.Clear();
            scope1.Channels[1].Data.Clear();

            for( int i = 0; i < SAMPLES; ++i )
            {
                ATrainingData[ i ][ 0 ] = i * 4;
                AResponses[i][0] = Math.Abs(Math.Sin((double)i / 10) + Math.Sin( (double)i / 3 + 0.1) * 0.1) / 4;
                scope1.Channels[0].Data.AddXYPoint(ATrainingData[i][0], AResponses[i][0]);
            }

            neuralNetworkBackpropTrain1.Train( ATrainingData, AResponses );

            // Test the Neural Network
            Mitov.SignalLab.RealBuffer ATestData = new Mitov.SignalLab.RealBuffer(1);
            for( int i = 0; i < SAMPLES * 4; ++i )
            {
                ATestData[ 0 ] = i;
                neuralNetwork1.Predict( ATestData );
            }
        }

        private void neuralNetwork1_Result(object Sender, Mitov.IntelligenceLab.ClassifierResultEventArgs Args)
        {
            scope1.Channels[1].Data.AddXYPoint(Args.Features[0], Args.Result.Results[0]);
        }
    }
}
